string description = "Simple noise by jl";

float4x4 worldViewProj : WorldViewProjection;

texture noiseTexture
<
	string ResourceName = "saltnpeppa.dds";
>;

struct vertexInput {
    float3 position : POSITION;
    float4 texCoord : TEXCOORD0;
};

struct vertexOutput {
    float4 hPosition : POSITION;
    float4 texCoord : TEXCOORD0;
};

vertexOutput VS_Transform(vertexInput IN) 
{
    vertexOutput OUT;
    OUT.hPosition = mul( float4(IN.position.xyz, 1.0), worldViewProj);
    OUT.texCoord = IN.texCoord;

    return OUT;
}

sampler NoiseSampler = sampler_state 
{
    texture = <noiseTexture>;
    AddressU  = WRAP;        
    AddressV  = WRAP;
    MIPFILTER = LINEAR;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

float4 PS_Noise(vertexOutput IN) : COLOR
{
  float2 uv = 0.1*IN.texCoord;
  const float f = 2.07;
  float a;
  a  = 0.5*tex2D(NoiseSampler, uv).r;
  a += 0.3*tex2D(NoiseSampler, f*uv).r;
  a += 0.2*tex2D(NoiseSampler, f*f*uv).r;
  a += 0.1*tex2D(NoiseSampler, f*f*f*uv).r;
  //a = (a-0.5)*10 + 0.5;
  a = (a-0.58)*10 + 0.5;
  //a = sin(50.0*IN.texCoord.y + 1.2*a);
  //return float4(a, a, a, 1.0);
  return float4(a, a, 1.0, 1.0);
}

technique noise
{
    pass p0 
    {		
		VertexShader = compile vs_3_0 VS_Transform();
		PixelShader  = compile ps_3_0 PS_Noise();
    }
}